#include <bits/stdc++.h>
using namespace std;
bool visited[2000][2000];
long long n, m;
bool v(long long y, long long  x)
{
    if(y < 1 || x < 1 || x > m || y > n) return 1;
    return visited[y][x];
}
void dfs(long long y, long long x)
{
    visited[y][x] = 1;
    if(!v(y + 1, x)) dfs(y + 1, x);
    if(!v(y, x + 1)) dfs(y, x + 1);
    if(!v(y - 1, x)) dfs(y - 1, x);
    if(!v(y, x - 1)) dfs(y, x - 1);
}
int main()
{
    ios_base::sync_with_stdio(false);
    long long k, x, y, ans = 0;
    cin >> n >> m >> k;
    while(k--)
    {
        cin >> x >> y;
        visited[y][x] = 1;
    }
    for(y = 1; y <= n; y++)
        for(x = 1; x <= m; x++)
            if(!visited[y][x])
            {
                dfs(y, x);
                ans++;
            }

    cout << ans;
    return 0;
}